Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
IpoptRNLP Class Reference

`#include <IpoptRNLP.hpp>`

Inheritance diagram for IpoptRNLP:
[legend]

## Public Member Functions
| IpoptRNLP ()
| default constructor More...
virtual | ~IpoptRNLP ()
| default destructor More...
void | set_R_environment (SEXP env)
void | set_R_eval_f (SEXP f)
void | set_R_eval_grad_f (SEXP f)
void | set_R_init_values (SEXP x0)
void | set_R_lower_bounds (SEXP lb)
void | set_R_upper_bounds (SEXP ub)
void | set_R_eval_g (SEXP g)
void | set_R_eval_jac_g (SEXP g)
void | set_R_eval_jac_g_structure (SEXP s)
void | set_R_constraint_lower_bounds (SEXP lb)
void | set_R_constraint_upper_bounds (SEXP ub)
void | set_R_eval_h (SEXP h)
void | set_R_eval_h_structure (SEXP s)
void | set_hessian_approximation (bool b)
SEXP | get_R_result_list ()
Overloaded from TNLP
virtual bool | get_nlp_info (Ipopt::Index &n, Ipopt::Index &m, Ipopt::Index &nnz_jac_g, Ipopt::Index &nnz_h_lag, IndexStyleEnum &Index_style)
| Method to return some info about the nlp. More...
virtual bool | get_bounds_info (Ipopt::Index n, Ipopt::Number *x_l, Ipopt::Number *x_u, Ipopt::Index m, Ipopt::Number *g_l, Ipopt::Number *g_u)
| Method to return the bounds for my problem. More...
virtual bool | get_starting_point (Ipopt::Index n, bool init_x, Ipopt::Number *x, bool init_z, Ipopt::Number *z_L, Ipopt::Number *z_U, Ipopt::Index m, bool init_lambda, Ipopt::Number *lambda)
| Method to return the starting point for the algorithm. More...
virtual bool | eval_f (Ipopt::Index n, const Ipopt::Number *x, bool new_x, Ipopt::Number &obj_value)
| Method to return the objective value. More...
virtual bool | eval_grad_f (Ipopt::Index n, const Ipopt::Number *x, bool new_x, Ipopt::Number *grad_f)
| Method to return the gradient of the objective. More...
virtual bool | eval_g (Ipopt::Index n, const Ipopt::Number *x, bool new_x, Ipopt::Index m, Ipopt::Number *g)
| Method to return the constraint residuals. More...
virtual bool | eval_jac_g (Ipopt::Index n, const Ipopt::Number *x, bool new_x, Ipopt::Index m, Ipopt::Index nele_jac, Ipopt::Index *iRow, Ipopt::Index *jCol, Ipopt::Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL) More...
virtual bool | eval_h (Ipopt::Index n, const Ipopt::Number *x, bool new_x, Ipopt::Number obj_factor, Ipopt::Index m, const Ipopt::Number *lambda, bool new_lambda, Ipopt::Index nele_hess, Ipopt::Index *iRow, Ipopt::Index *jCol, Ipopt::Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL) More...
Solution Methods
virtual void | finalize_solution (Ipopt::SolverReturn status, Ipopt::Index n, const Ipopt::Number *x, const Ipopt::Number *z_L, const Ipopt::Number *z_U, Ipopt::Index m, const Ipopt::Number *g, const Ipopt::Number *lambda, Ipopt::Number obj_value, const Ipopt::IpoptData *ip_data, Ipopt::IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution. More...
Public Member Functions inherited from Ipopt::TNLP
| DECLARE_STD_EXCEPTION (INVALID_TNLP)
| TNLP ()
virtual | ~TNLP ()
| Default destructor. More...
virtual void | finalize_metadata (Index n, const StringMetaDataMapType &var_string_md, const IntegerMetaDataMapType &var_integer_md, const NumericMetaDataMapType &var_numeric_md, Index m, const StringMetaDataMapType &con_string_md, const IntegerMetaDataMapType &con_integer_md, const NumericMetaDataMapType &con_numeric_md)
| This method is called just before finalize_solution. More...
virtual bool | intermediate_callback (AlgorithmMode mode, Index iter, Number obj_value, Number inf_pr, Number inf_du, Number mu, Number d_norm, Number regularization_size, Number alpha_du, Number alpha_pr, Index ls_trials, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| Intermediate Callback method for the user. More...
virtual Index | get_number_of_nonlinear_variables ()
virtual bool | get_list_of_nonlinear_variables (Index num_nonlin_vars, Index *pos_nonlin_vars)
virtual bool | get_var_con_metadata (Index n, StringMetaDataMapType &var_string_md, IntegerMetaDataMapType &var_integer_md, NumericMetaDataMapType &var_numeric_md, Index m, StringMetaDataMapType &con_string_md, IntegerMetaDataMapType &con_integer_md, NumericMetaDataMapType &con_numeric_md)
| overload this method to return any meta data for the variables and the constraints More...
virtual bool | get_scaling_parameters (Number &obj_scaling, bool &use_x_scaling, Index n, Number *x_scaling, bool &use_g_scaling, Index m, Number *g_scaling)
| overload this method to return scaling parameters. More...
virtual bool | get_variables_linearity (Index n, LinearityType *var_types)
| overload this method to return the variables linearity (TNLP::LINEAR or TNLP::NON_LINEAR). More...
virtual bool | get_constraints_linearity (Index m, LinearityType *const_types)
| overload this method to return the constraint linearity. More...
virtual bool | get_warm_start_iterate (IteratesVector &warm_start_iterate)
| overload this method to provide an Ipopt iterate (already in the form Ipopt requires it internally) for a warm start. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const

## Private Member Functions
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| IpoptRNLP (const IpoptRNLP &)
IpoptRNLP & | operator= (const IpoptRNLP &)

## Private Attributes
SEXP | R_environment
SEXP | R_eval_f
SEXP | R_eval_grad_f
SEXP | R_init_values
SEXP | R_lower_bounds
SEXP | R_upper_bounds
SEXP | R_eval_g
SEXP | R_eval_jac_g
SEXP | R_eval_jac_g_structure
SEXP | R_constraint_lower_bounds
SEXP | R_constraint_upper_bounds
SEXP | R_eval_h
SEXP | R_eval_h_structure
SEXP | R_result_list
bool | d_hessian_approximation
int | d_num_protected_members

## Additional Inherited Members
Public Types inherited from Ipopt::TNLP
enum | LinearityType { LINEAR, NON_LINEAR }
| Type of the constraints. More...
enum | IndexStyleEnum { C_STYLE =0, FORTRAN_STYLE =1 }
| overload this method to return the number of variables and constraints, and the number of non-zeros in the jacobian and the hessian. More...
typedef std::map< std::string, std::vector< std::string > > | StringMetaDataMapType
typedef std::map< std::string, std::vector< Index > > | IntegerMetaDataMapType
typedef std::map< std::string, std::vector< Number > > | NumericMetaDataMapType

## Detailed Description

Definition at line 31 of file IpoptRNLP.hpp.

## Constructor & Destructor Documentation

IpoptRNLP::IpoptRNLP | ( |  | ) |

default constructor

virtual IpoptRNLP::~IpoptRNLP | ( |  | ) |
| virtual

default destructor

IpoptRNLP::IpoptRNLP | ( | const IpoptRNLP & |  | ) |
| private

## Member Function Documentation

void IpoptRNLP::set_R_environment | ( | SEXP | env | ) |

void IpoptRNLP::set_R_eval_f | ( | SEXP | f | ) |

void IpoptRNLP::set_R_eval_grad_f | ( | SEXP | f | ) |

void IpoptRNLP::set_R_init_values | ( | SEXP | x0 | ) |

void IpoptRNLP::set_R_lower_bounds | ( | SEXP | lb | ) |

void IpoptRNLP::set_R_upper_bounds | ( | SEXP | ub | ) |

void IpoptRNLP::set_R_eval_g | ( | SEXP | g | ) |

void IpoptRNLP::set_R_eval_jac_g | ( | SEXP | g | ) |

void IpoptRNLP::set_R_eval_jac_g_structure | ( | SEXP | s | ) |

void IpoptRNLP::set_R_constraint_lower_bounds | ( | SEXP | lb | ) |

void IpoptRNLP::set_R_constraint_upper_bounds | ( | SEXP | ub | ) |

void IpoptRNLP::set_R_eval_h | ( | SEXP | h | ) |

void IpoptRNLP::set_R_eval_h_structure | ( | SEXP | s | ) |

void IpoptRNLP::set_hessian_approximation | ( | bool | b | ) |

SEXP IpoptRNLP::get_R_result_list | ( |  | ) |

virtual bool IpoptRNLP::get_nlp_info | ( | Ipopt::Index & | n,
|  | Ipopt::Index & | m,
|  | Ipopt::Index & | nnz_jac_g,
|  | Ipopt::Index & | nnz_h_lag,
|  | IndexStyleEnum & | Index_style
| ) |  |
| virtual

Method to return some info about the nlp.

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::get_bounds_info | ( | Ipopt::Index | n,
|  | Ipopt::Number * | x_l,
|  | Ipopt::Number * | x_u,
|  | Ipopt::Index | m,
|  | Ipopt::Number * | g_l,
|  | Ipopt::Number * | g_u
| ) |  |
| virtual

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::get_starting_point | ( | Ipopt::Index | n,
|  | bool | init_x,
|  | Ipopt::Number * | x,
|  | bool | init_z,
|  | Ipopt::Number * | z_L,
|  | Ipopt::Number * | z_U,
|  | Ipopt::Index | m,
|  | bool | init_lambda,
|  | Ipopt::Number * | lambda
| ) |  |
| virtual

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::eval_f | ( | Ipopt::Index | n,
|  | const Ipopt::Number * | x,
|  | bool | new_x,
|  | Ipopt::Number & | obj_value
| ) |  |
| virtual

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::eval_grad_f | ( | Ipopt::Index | n,
|  | const Ipopt::Number * | x,
|  | bool | new_x,
|  | Ipopt::Number * | grad_f
| ) |  |
| virtual

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::eval_g | ( | Ipopt::Index | n,
|  | const Ipopt::Number * | x,
|  | bool | new_x,
|  | Ipopt::Index | m,
|  | Ipopt::Number * | g
| ) |  |
| virtual

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::eval_jac_g | ( | Ipopt::Index | n,
|  | const Ipopt::Number * | x,
|  | bool | new_x,
|  | Ipopt::Index | m,
|  | Ipopt::Index | nele_jac,
|  | Ipopt::Index * | iRow,
|  | Ipopt::Index * | jCol,
|  | Ipopt::Number * | values
| ) |  |
| virtual

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL)

Implements Ipopt::TNLP.

virtual bool IpoptRNLP::eval_h | ( | Ipopt::Index | n,
|  | const Ipopt::Number * | x,
|  | bool | new_x,
|  | Ipopt::Number | obj_factor,
|  | Ipopt::Index | m,
|  | const Ipopt::Number * | lambda,
|  | bool | new_lambda,
|  | Ipopt::Index | nele_hess,
|  | Ipopt::Index * | iRow,
|  | Ipopt::Index * | jCol,
|  | Ipopt::Number * | values
| ) |  |
| virtual

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL)

Reimplemented from Ipopt::TNLP.

virtual void IpoptRNLP::finalize_solution | ( | Ipopt::SolverReturn | status,
|  | Ipopt::Index | n,
|  | const Ipopt::Number * | x,
|  | const Ipopt::Number * | z_L,
|  | const Ipopt::Number * | z_U,
|  | Ipopt::Index | m,
|  | const Ipopt::Number * | g,
|  | const Ipopt::Number * | lambda,
|  | Ipopt::Number | obj_value,
|  | const Ipopt::IpoptData * | ip_data,
|  | Ipopt::IpoptCalculatedQuantities * | ip_cq
| ) |  |
| virtual

This method is called when the algorithm is complete so the TNLP can store/write the solution.

Implements Ipopt::TNLP.

IpoptRNLP& IpoptRNLP::operator= | ( | const IpoptRNLP & |  | ) |
| private

## Member Data Documentation

SEXP IpoptRNLP::R_environment
| private

Definition at line 33 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_f
| private

Definition at line 35 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_grad_f
| private

Definition at line 36 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_init_values
| private

Definition at line 38 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_lower_bounds
| private

Definition at line 40 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_upper_bounds
| private

Definition at line 41 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_g
| private

Definition at line 43 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_jac_g
| private

Definition at line 44 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_jac_g_structure
| private

Definition at line 45 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_constraint_lower_bounds
| private

Definition at line 47 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_constraint_upper_bounds
| private

Definition at line 48 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_h
| private

Definition at line 50 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_eval_h_structure
| private

Definition at line 51 of file IpoptRNLP.hpp.

SEXP IpoptRNLP::R_result_list
| private

Definition at line 53 of file IpoptRNLP.hpp.

bool IpoptRNLP::d_hessian_approximation
| private

Definition at line 55 of file IpoptRNLP.hpp.

int IpoptRNLP::d_num_protected_members
| private

Definition at line 57 of file IpoptRNLP.hpp.

The documentation for this class was generated from the following file:

- contrib/RInterface/src/IpoptRNLP.hpp